package com.nokia.tsl_data;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.apache.commons.csv.CSVFormat;
import org.apache.commons.csv.CSVParser;
import org.apache.commons.csv.CSVRecord;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.jdbc.core.JdbcTemplate;

@SpringBootTest
public class TslDataApplicationTest {
    @Autowired
    private JdbcTemplate jdbcTemplate;

    @Test
    void test() {
        String path = "D:/hb_cuc_code/report_auto/doc/开发文档/样本数据/输入/HE_D_MOBILE_COMPLAINT_DETAILS_DAY_20230409-src.csv";

        //
        String sql = "insert into report_auto.he_d_mobile_comp (month_id,day_id,acct_date,sheet_no,is_online_complete,contact_no,busi_no,serv_content,last_deal_content,deal_depart_name,deal_opinion,serv_type,bus_type,duty_reason,accept_channel,submit_channel,compl_area_local,duty_major,product_name,sp_product_code,pre_repair_name,pre_repair_charges,fault_location,cust_level,satisfaction_in_reply,is_ok_in_reply,accept_time,end_time,proce_time,cust_area,is_cust_serv_complete,is_send_sheet_complete,is_repeat,is_upgrade,is_timeout,gis_city,process_nums,deal_depart_name_1,deal_depart_name_2,deal_depart_name_3,first_call_back_time,proce_remark,duty_major_day,duty_reason_id_day,duty_major_month,duty_reason_id_month,voice_text) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?);";

        // String sql = "insert into report_auto.he_d_mobile_comp (month_id,day_id,acct_date) values (?,?,?)";
        try (Reader reader = new InputStreamReader(new FileInputStream(path), StandardCharsets.UTF_8)) {

            CSVParser parser = CSVFormat.DEFAULT.builder()
                    .setRecordSeparator("\n")
                    .setQuote(null)
                    .setDelimiter("||")
                    .setSkipHeaderRecord(false)
                    .build().parse(reader);

            List<CSVRecord> records = parser.getRecords();
            List<Object[]> list = new ArrayList<>();
            for (int i = 0; i < 10; i++) {
                // Object[] ps = new String[] { "202304", "09", "20230409" };
                Object[] ps = new Object[47];
                list.add(ps);
                for (int j = 0; j < ps.length; j++) {
                    ps[j] = records.get(i).get(j);
                }
            }

            int[] batchUpdate = jdbcTemplate.batchUpdate(sql, list);
            System.out.println(Arrays.toString(batchUpdate));

        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}
